.386				; 32 bit when .386 appears before .MODEL
.MODEL FLAT,STDCALL
option casemap :none   		; case sensitive

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include	\masm32\include\comctl32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
include \masm32\macros\macros.asm

WinMain	PROTO :DWORD, :DWORD, :DWORD, :SDWORD

BITMAPSIZE	EQU	1024

.data
	szWinName	db "P3S_BR3",0
	szTitle		db "Demonstrate BMP",0

	hBmBkgd		db "MYBP1",0		
	hBmBlock	db "MYBP2",0		

.data?
	hInstance	HINSTANCE ?
	CommandLine	LPSTR ?

	maxX		dd ?		; Screen dimensions
	maxY		dd ?

	hbmp1		HBITMAP ?	; Animation bitmap handles
	hbmp2		HBITMAP	?

	hbit1		HBITMAP	?	; Bitmap handles
	hbrush		HBRUSH	?	; Brush handle

	memdc		HDC ?		; Virtual device handle
	tempdc1		HDC ?
	tempdc2		HDC ?

return  MACRO arg
        mov eax, arg
        ret
ENDM

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
        invoke WinMain, hInstance,NULL,EAX, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD
	LOCAL wc:WNDCLASSEX, msg:MSG, hwnd:HWND

	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.lpszClassName,OFFSET szWinName
	m2m   wc.hInstance,hInstance
	mov   wc.lpfnWndProc, OFFSET WndProc
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax			; Cursor style
	invoke LoadIcon,hInst, 4		; 4=my_ico		
 	mov   wc.hIcon,eax			; Large icon
 	mov   wc.hIconSm,eax			; Small icon
	mov   wc.lpszMenuName,0			; No main menu
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.style, 0			; default style
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
       
        invoke RegisterClassEx, addr wc
	.IF   !eax
		return 0
	.ENDIF

	invoke LoadBitmap, hInst, ADDR hBmBkgd		
	mov hbmp1,eax 	
	invoke LoadBitmap, hInst, ADDR hBmBlock
	mov hbmp2,eax 	
		
        invoke CreateWindowEx,NULL,ADDR szWinName,ADDR szTitle,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT, CW_USEDEFAULT, \
	   CW_USEDEFAULT,CW_USEDEFAULT,HWND_DESKTOP,NULL, hInst,NULL

        mov hwnd,eax

        invoke ShowWindow, hwnd, CmdShow	
        invoke UpdateWindow, hwnd

        .WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)

		invoke TranslateMessage, ADDR msg
                invoke DispatchMessage, ADDR msg

        .ENDW

        mov eax,msg.wParam
        ret
WinMain endp

WndProc proc  uses esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	LOCAL ps:PAINTSTRUCT, hdc:HDC

	.IF uMsg==WM_CREATE
		invoke GetSystemMetrics, SM_CXSCREEN			  
		mov maxX,eax
		invoke GetSystemMetrics, SM_CYSCREEN
		mov maxY,eax

		invoke GetDC, hWnd
		mov hdc,eax
		
		invoke CreateCompatibleDC, hdc
		mov memdc,eax
		
		invoke CreateCompatibleBitmap, hdc, maxX, maxY
		mov hbit1,eax
		
		invoke SelectObject, memdc, hbit1
		invoke GetStockObject, WHITE_BRUSH ;GRAY_BRUSH  
		mov hbrush,eax
		invoke SelectObject, memdc, hbrush
		invoke PatBlt, memdc, 0, 0, maxX, maxY, PATCOPY ;Copies the specified pattern into the destination bitmap
		
		invoke CreateCompatibleDC, hdc
		mov tempdc1,eax
		invoke CreateCompatibleDC, hdc
		mov tempdc2,eax
;===================================================================================================
		invoke SelectObject, tempdc1, hbmp1
		invoke BitBlt, memdc, 0, 0, BITMAPSIZE, BITMAPSIZE, tempdc1,  0, 0, MERGECOPY;SRCAND
		
		invoke SelectObject, tempdc2, hbmp2
		invoke BitBlt, memdc, 250, 70, BITMAPSIZE, BITMAPSIZE, tempdc2, 0, 0, MERGECOPY;SRCAND
;===================================================================================================
        .ELSEIF uMsg==WM_PAINT
		invoke BeginPaint, hWnd, ADDR ps	
		mov hdc,eax	 

		mov eax,ps.rcPaint.right
		sub eax,ps.rcPaint.left		; width
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top		; height
	
		invoke BitBlt, hdc, ps.rcPaint.left, ps.rcPaint.top, eax, ecx, \ 
			  memdc, ps.rcPaint.left, ps.rcPaint.top, SRCCOPY

		invoke EndPaint, hWnd, ADDR ps

	.ELSEIF uMsg==WM_DESTROY

		invoke DeleteDC, memdc
		invoke DeleteDC, tempdc1
		invoke DeleteDC, tempdc2
		invoke PostQuitMessage,NULL
	    
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF

	return 0

WndProc endp

end start

